/*====================================================================
      File rtest.sql

      rFunc InterBase UDF library.
      SQL-script for testing rFunc.

      Copyright 1998-2001 Polaris Software
      http://polesoft.da.ru
      mailto: rFunc@mail.ru

      Version 2.0.1.2
====================================================================== */

SET NAMES win1251;

/* Define valid path and password for your database */
/* 4.2 Windows local */
/*CONNECT "d:\progra~1\borland\intrbase\examples\employee.gdb" USER "SYSDBA" PASSWORD "masterkey";*/
/* 5.x Windows local */
/*CONNECT "d:\progra~1\interb~1\interb~1\examples\database\employee.gdb" USER "SYSDBA" PASSWORD "masterkey";*/
/* 5.x Linux remote */
/*CONNECT "iblinux:/usr/local/interbase/examples/employee.gdb" USER "SYSDBA" PASSWORD "masterkey";*/
/* 6.x Windows local Firebird Dialect 1 */
/*CONNECT "d:\progra~1\firebird\examples\v5\employee.gdb" USER "SYSDBA" PASSWORD "masterkey";*/
/* 6.x Windows local Borland Dialect 1 */
/*CONNECT "d:\progra~1\borland\interbase\examples\database\employee.gdb" USER "SYSDBA" PASSWORD "masterkey";*/
/* 6.x Windows local Dialect 3 */
/*CONNECT 'e:\ibase5\test\test6.gdb' USER 'SYSDBA' PASSWORD 'masterkey';*/
/* 6.x Linux remote Dialect 1 */
/*CONNECT "iblinux:/opt/interbase/examples/employee.gdb" USER "SYSDBA" PASSWORD "masterkey";*/
/* 6.x Linux remote Dialect 3 */
/*CONNECT "mlinux:/base/test6.gdb" USER "SYSDBA" PASSWORD "masterkey";*/

DROP PROCEDURE R_RFUNC_TEST_BLOB;
DROP TRIGGER T_BI_COMMAND;
DROP TRIGGER T_BI_COMMAND2;
DELETE FROM R_TEST_RFUNC;
COMMIT;
CREATE TABLE R_TEST_RFUNC (R_COMMAND VARCHAR(127), R_RESULT VARCHAR(127));

SET TERM ^;

/* valid only for IB for Windows */
CREATE TRIGGER T_BI_COMMAND FOR R_TEST_RFUNC
ACTIVE BEFORE INSERT POSITION 0
AS
  DECLARE VARIABLE I INTEGER;
BEGIN
  IF (StrPos('Add_User', NEW.R_COMMAND) = 1) THEN
    SELECT MsgBox('User added!!!', 'rFunc test', 0) FROM RDB$DATABASE INTO I;
  ELSE IF (StrPos('Modify_User', NEW.R_COMMAND) = 1) THEN
    SELECT MsgBox('User modified!!!', 'rFunc test', 0) FROM RDB$DATABASE INTO I;
  ELSE IF (StrPos('Delete_User', NEW.R_COMMAND) = 1) THEN
    SELECT MsgBox('User deleted!!!', 'rFunc test', 0) FROM RDB$DATABASE INTO I;
END ^

CREATE TRIGGER T_BI_COMMAND2 FOR R_TEST_RFUNC
ACTIVE BEFORE INSERT POSITION 1
AS
BEGIN
  IF (StrLen(Trim(NEW.R_COMMAND)) = 0) THEN
    NEW.R_COMMAND = 'Unknown command';
END ^

CREATE PROCEDURE R_RFUNC_TEST_BLOB 
AS
  DECLARE VARIABLE B BLOB SUB_TYPE TEXT SEGMENT SIZE 40;
BEGIN
  /* Select T_BI_COMMAND2 trigger body */
  SELECT RDB$TRIGGER_SOURCE 
    FROM RDB$TRIGGERS
   WHERE RDB$TRIGGER_NAME = 'T_BI_COMMAND2'
    INTO B;
  INSERT INTO R_TEST_RFUNC VALUES ('B_Number_Segments(B) [B is T_BI_COMMAND2 trigger body]', b_number_segments(:B));
  INSERT INTO R_TEST_RFUNC VALUES ('B_Max_Segment(B)', b_max_segment(:B));
  INSERT INTO R_TEST_RFUNC VALUES ('B_Total_Length(B)', b_total_length(:B));
  INSERT INTO R_TEST_RFUNC VALUES ('B_Line_Count(B)', b_line_count(:B));
  INSERT INTO R_TEST_RFUNC VALUES ('B_Substr(B, 1, 10)', b_substr(:B, 1, 10));
  INSERT INTO R_TEST_RFUNC VALUES ('B_Substr(B, 20, 10)', b_substr(:B, 20, 10));
  INSERT INTO R_TEST_RFUNC VALUES ('B_Line(B, 1)', b_line(:B, 1));
  /* Check old T_BI_COMMAND2 trigger body */
  INSERT INTO R_TEST_RFUNC VALUES ('B_Line(B, 4)', b_line(:B, 4));
/*  INSERT INTO R_TEST_RFUNC VALUES ('', '[trigger test]');*/
  INSERT INTO R_TEST_RFUNC VALUES ('LongStrReplace(B_LongSubstr(B, 1, B_Total_Length(B)), "Unknown", "BAD")', 
                                   LongStrReplace(B_LongSubstr(:B, 1, B_Total_Length(:B)), 'Unknown', 'BAD'));
  /* Change T_BI_COMMAND2 trigger body */
  UPDATE RDB$TRIGGERS SET RDB$TRIGGER_SOURCE = B_Put_Segment(LongStrReplace(B_LongSubstr(:B, 1, B_Total_Length(:B)), 'Unknown', 'BAD'))
   WHERE RDB$TRIGGER_NAME = 'T_BI_COMMAND2';
  INSERT INTO R_TEST_RFUNC VALUES ('B = B_Put_Segment(LongStrReplace(B_LongSubstr(B, 1, B_Total_Length(B)), "Unknown", "BAD")', 
                                   '[change T_BI_COMMAND2 trigger]');
  /* Check new T_BI_COMMAND2 trigger body */
  SELECT RDB$TRIGGER_SOURCE 
    FROM RDB$TRIGGERS
   WHERE RDB$TRIGGER_NAME = 'T_BI_COMMAND2'
    INTO B;
  INSERT INTO R_TEST_RFUNC VALUES ('B_Line(B, 4)', b_line(:B, 4));
END ^

SET TERM ;^

/* Date&Time functions */

INSERT INTO R_TEST_RFUNC VALUES ('DateTime functions', '----------------');

INSERT INTO R_TEST_RFUNC VALUES ('Quarter("NOW")', quarter('NOW'));

/* valid only for IB 4.2 and 5.x */
INSERT INTO R_TEST_RFUNC VALUES ('Year("NOW")', year('NOW'));
INSERT INTO R_TEST_RFUNC VALUES ('Month("NOW")', month('NOW'));
INSERT INTO R_TEST_RFUNC VALUES ('Day("NOW")', day('NOW'));
INSERT INTO R_TEST_RFUNC VALUES ('YearDay("NOW")', yearday('NOW'));
INSERT INTO R_TEST_RFUNC VALUES ('WeekDay("NOW")', weekday('NOW'));
INSERT INTO R_TEST_RFUNC VALUES ('Hour("NOW")', hour('NOW'));
INSERT INTO R_TEST_RFUNC VALUES ('Minute("NOW")', minute('NOW'));
INSERT INTO R_TEST_RFUNC VALUES ('Second("NOW")', second('NOW'));

INSERT INTO R_TEST_RFUNC VALUES ('DOW("NOW")', dow('NOW'));
INSERT INTO R_TEST_RFUNC VALUES ('DateToStr("NOW", "%d.%m.%y")', datetostr('NOW', '%d.%m.%y'));
INSERT INTO R_TEST_RFUNC VALUES ('DateToStr("NOW", "%d %B %Y, %X")', datetostr('NOW', '%d %B %Y, %X'));
INSERT INTO R_TEST_RFUNC VALUES ('EncodeDate(3, 5, 2001)', encodedate(3, 5, 2001));
INSERT INTO R_TEST_RFUNC VALUES ('EncodeDate(0, 5, 2001)', encodedate(0, 5, 2001));
INSERT INTO R_TEST_RFUNC VALUES ('EncodeDateTime(3, 5, 2001, 12, 14, 35)', encodedatetime(3, 5, 2001, 12, 14, 35));
INSERT INTO R_TEST_RFUNC VALUES ('EncodeDateTime(3, 5, 99, 12, 14, 66)', encodedatetime(3, 5, 99, 12, 14, 66));
INSERT INTO R_TEST_RFUNC VALUES ('ExtractDate("NOW")', extractdate('NOW'));
INSERT INTO R_TEST_RFUNC VALUES ('ExtractTime("NOW")', extracttime('NOW'));
INSERT INTO R_TEST_RFUNC VALUES ('DayPerMonth(Month("NOW"), Year("NOW"))', daypermonth(month('NOW'), year('NOW')));
INSERT INTO R_TEST_RFUNC VALUES ('DayPerMonth(2, 1996)', daypermonth(2, 1996));
INSERT INTO R_TEST_RFUNC VALUES ('FirstDayMonth("NOW")', firstdaymonth('NOW'));
INSERT INTO R_TEST_RFUNC VALUES ('LastDayMonth("NOW")', lastdaymonth('NOW'));
INSERT INTO R_TEST_RFUNC VALUES ('IsLeapYear(Year("NOW"))', isleapyear(year('NOW')));
INSERT INTO R_TEST_RFUNC VALUES ('IsLeapYear(1996)', isleapyear(1996));
INSERT INTO R_TEST_RFUNC VALUES ('DaysBetween(FirstDayMonth("NOW"), "NOW")', daysbetween(FirstDayMonth('NOW'), 'NOW'));
INSERT INTO R_TEST_RFUNC VALUES ('DaysBetween("NOW", FirstDayMonth("NOW"))', daysbetween('NOW', FirstDayMonth('NOW')));
INSERT INTO R_TEST_RFUNC VALUES ('IncDate("NOW", 0, 2, 0))', incdate('NOW', 0, 2, 0));
INSERT INTO R_TEST_RFUNC VALUES ('IncDate("NOW", -1, 2, -2))', incdate('NOW', -1, 2, -2));
COMMIT;

/* Math functions */

INSERT INTO R_TEST_RFUNC VALUES ('Math functions', '----------------');

INSERT INTO R_TEST_RFUNC VALUES ('Abs(-23)', abs(-23));
INSERT INTO R_TEST_RFUNC VALUES ('MaxNum(23, 45)', maxnum(23, 45));
INSERT INTO R_TEST_RFUNC VALUES ('MinNum(23, 45)', minnum(23, 45));
INSERT INTO R_TEST_RFUNC VALUES ('Ceil(23.5)', ceil(23.5));
INSERT INTO R_TEST_RFUNC VALUES ('Floor(23.5)', floor(23.5));
INSERT INTO R_TEST_RFUNC VALUES ('Power(256, 0)', power(256, 0));
INSERT INTO R_TEST_RFUNC VALUES ('Power(256, 0.5)', power(256, 0.5));
INSERT INTO R_TEST_RFUNC VALUES ('Power(256, 2)', power(256, 2));
INSERT INTO R_TEST_RFUNC VALUES ('Power(256, -1)', power(256, -1));
INSERT INTO R_TEST_RFUNC VALUES ('Power(-2, 2)', power(-2, 2));
INSERT INTO R_TEST_RFUNC VALUES ('Round(23.45, 0)', round(23.45, 0));
INSERT INTO R_TEST_RFUNC VALUES ('Round(23.45, 1)', round(23.45, 1));
INSERT INTO R_TEST_RFUNC VALUES ('Round(23.45, -1)', round(23.45, -1));
INSERT INTO R_TEST_RFUNC VALUES ('Round(0.45, 0)', round(0.45, 0));
INSERT INTO R_TEST_RFUNC VALUES ('SoftRound(0.45, 0)', softround(0.45, 0));
INSERT INTO R_TEST_RFUNC VALUES ('Div(5, 2)', div(5, 2));
INSERT INTO R_TEST_RFUNC VALUES ('Mod(5, 2)', mod(5, 2));
INSERT INTO R_TEST_RFUNC VALUES ('Z(NULL)', z(CAST(NULL AS INTEGER)));
INSERT INTO R_TEST_RFUNC VALUES ('Z(23.4)', z(23.4));
INSERT INTO R_TEST_RFUNC VALUES ('DZero(5, 2, -1)', dzero(5, 2, -1));
INSERT INTO R_TEST_RFUNC VALUES ('DZero(5, 0, -1)', dzero(5, 0, -1));
INSERT INTO R_TEST_RFUNC VALUES ('InitRandom(1000)', initrandom(1000));
INSERT INTO R_TEST_RFUNC VALUES ('GetRandom(1000)', getrandom(1000));
INSERT INTO R_TEST_RFUNC VALUES ('GetRandom(1000)', getrandom(1000));
INSERT INTO R_TEST_RFUNC VALUES ('GetRandom(1000)', getrandom(1000));
INSERT INTO R_TEST_RFUNC VALUES ('GetBit(5,2) || GetBit(5,1) || GetBit(5,0)', getbit(5, 2)||getbit(5, 1)||getbit(5, 0));
INSERT INTO R_TEST_RFUNC VALUES ('SetBit(5, 1, 1)', setbit(5, 1, 1));
INSERT INTO R_TEST_RFUNC VALUES ('SetBit(5, 0, 0)', setbit(5, 0, 0));
INSERT INTO R_TEST_RFUNC VALUES ('BitAnd(5, 9) [0101 AND 1001 = 0001]', bitand(5, 9));
INSERT INTO R_TEST_RFUNC VALUES ('BitOr(5, 9)  [0101 OR  1001 = 1101]', bitor(5, 9));
INSERT INTO R_TEST_RFUNC VALUES ('BitXor(5, 9) [0101 XOR 1001 = 1100]', bitxor(5, 9));
INSERT INTO R_TEST_RFUNC VALUES ('BitNot(5)', bitnot(5));
COMMIT;

/* String functions */

INSERT INTO R_TEST_RFUNC VALUES ('String functions', '----------------');

INSERT INTO R_TEST_RFUNC VALUES ('Chr(65)', chr(65));
INSERT INTO R_TEST_RFUNC VALUES ('Ord("A")', ord('A'));
INSERT INTO R_TEST_RFUNC VALUES ('Trim("  rFunc  ")', '['||trim('  rFunc  ')||']');
INSERT INTO R_TEST_RFUNC VALUES ('LTrim("  rFunc  ")', '['||ltrim('  rFunc  ')||']');
INSERT INTO R_TEST_RFUNC VALUES ('RTrim("  rFunc  ")', '['||rtrim('  rFunc  ')||']');
INSERT INTO R_TEST_RFUNC VALUES ('RUpper(" rFunc") [it is russian]', rupper(' rFunc'));
INSERT INTO R_TEST_RFUNC VALUES ('RLower(" rFunc") [it is russian]', rlower(' rFunc'));
INSERT INTO R_TEST_RFUNC VALUES ('RLatin("rFunc -   :)") [it is russian]', rlatin('rFunc -   :)'));
INSERT INTO R_TEST_RFUNC VALUES ('RTranslit("rFunc -   :)") [it is russian]', rtranslit('rFunc -   :)'));
INSERT INTO R_TEST_RFUNC VALUES ('RLatin(".............") [it is russian]', rlatin('.............'));
INSERT INTO R_TEST_RFUNC VALUES ('RTranslit(".............") [it is russian]', rtranslit('.............'));
INSERT INTO R_TEST_RFUNC VALUES ('SubStr("rFunc", 2, 1)', substr('rFunc', 2, 1));
INSERT INTO R_TEST_RFUNC VALUES ('SubStr("rFunc", 2, 10)', substr('rFunc', 2, 10));
INSERT INTO R_TEST_RFUNC VALUES ('SubStr("rFunc", 2, -1)', substr('rFunc', 2, -1));
INSERT INTO R_TEST_RFUNC VALUES ('SubStr("rFunc", -2, 1)', substr('rFunc', -2, 1));
INSERT INTO R_TEST_RFUNC VALUES ('SubStr("rFunc", -2, -1)', substr('rFunc', -2, -1));
INSERT INTO R_TEST_RFUNC VALUES ('SubStr("rFunc", -2, -10)', substr('rFunc', -2, -10));
INSERT INTO R_TEST_RFUNC VALUES ('StrRepeat("rFunc", 2)', strrepeat('rFunc', 2));
INSERT INTO R_TEST_RFUNC VALUES ('StrStuff("rFunc", 2, 1, "Tr") [delete & insert]', strstuff('rFunc', 2, 1, 'Tr'));
INSERT INTO R_TEST_RFUNC VALUES ('StrStuff("rFunc", 2, 0, "us") [insert]', strstuff('rFunc', 2, 0, 'us'));
INSERT INTO R_TEST_RFUNC VALUES ('StrStuff("rFunc", 2, 1, "") [delete]', strstuff('rFunc', 2, 1, ''));
INSERT INTO R_TEST_RFUNC VALUES ('StrReplace("rFunc Fun", "Fun", "Pro")', strreplace('rFunc Fun', 'Fun', 'Pro'));
INSERT INTO R_TEST_RFUNC VALUES ('StrPos("Fu", "rFunc")', strpos('Fu', 'rFunc'));
INSERT INTO R_TEST_RFUNC VALUES ('StrPos("Fi", "rFunc")', strpos('Fi', 'rFunc'));
INSERT INTO R_TEST_RFUNC VALUES ('StrLen("rFunc")', strlen('rFunc'));
INSERT INTO R_TEST_RFUNC VALUES ('StrCount("un", "rFunc Fun")', strcount('un', 'rFunc Fun'));
INSERT INTO R_TEST_RFUNC VALUES ('WordCount("rFunc Fun", " ",  0)', wordcount('rFunc Fun', ' ', 0));
INSERT INTO R_TEST_RFUNC VALUES ('WordCount("rFunc Fun", " F", 0)', wordcount('rFunc Fun', ' F', 0));
INSERT INTO R_TEST_RFUNC VALUES ('WordCount("rFunc Fun", " F", 1)', wordcount('rFunc Fun', ' F', 1));
INSERT INTO R_TEST_RFUNC VALUES ('WordNum("rFunc Fun", 1, " ",  0)', wordnum('rFunc Fun', 1, ' ', 0));
INSERT INTO R_TEST_RFUNC VALUES ('WordNum("rFunc Fun", 3, " F", 0)', wordnum('rFunc Fun', 3, ' F', 0));
INSERT INTO R_TEST_RFUNC VALUES ('WordNum("rFunc Fun", 3, " F", 1)', wordnum('rFunc Fun', 3, ' F', 1));
INSERT INTO R_TEST_RFUNC VALUES ('PadLeft("rFunc", 10, "!")', padleft('rFunc', 10, '!'));
INSERT INTO R_TEST_RFUNC VALUES ('PadRight("rFunc", 10, "!")', padright('rFunc', 10, '!'));
COMMIT;

/* Miscellaneous functions */

INSERT INTO R_TEST_RFUNC VALUES ('Misc functions', '----------------');

INSERT INTO R_TEST_RFUNC VALUES ('IIf( 0, 11, 12)', iif(0, 11, 12));
INSERT INTO R_TEST_RFUNC VALUES ('IIf( 2, 11, 12)', iif(2, 11, 12));
INSERT INTO R_TEST_RFUNC VALUES ('IIf(-2, 11, 12)', iif(-2, 11, 12));
INSERT INTO R_TEST_RFUNC VALUES ('DIf( 0, 1.1, 1.2)', dif(0, 1.1, 1.2));
INSERT INTO R_TEST_RFUNC VALUES ('DIf( 1, 1.1, 1.2)', dif(1, 1.1, 1.2));
INSERT INTO R_TEST_RFUNC VALUES ('CIf( 0, "A", "B")', cif(0, 'A', 'B'));
INSERT INTO R_TEST_RFUNC VALUES ('CIf( 1, "A", "B")', cif(1, 'A', 'B'));
INSERT INTO R_TEST_RFUNC VALUES ('DtIf( 0, "NOW", "NOW"-1)', dtif(0, 'NOW', CAST('NOW' AS DATE)-1));
INSERT INTO R_TEST_RFUNC VALUES ('DtIf( 1, "NOW", "NOW"-1)', dtif(1, 'NOW', CAST('NOW' AS DATE)-1));
COMMIT;

/* valid only for IB for Windows */
INSERT INTO R_TEST_RFUNC VALUES ('MsgBox( , , 0)', msgbox('rFuncLib MsgBox(,,0)'||chr(13)||'It is working!!!', 'rFunc test', 0));
INSERT INTO R_TEST_RFUNC VALUES ('MsgBox( , , 1)', msgbox('rFuncLib MsgBox(,,1)'||chr(13)||'It is working!!!', 'rFunc test', 1));
COMMIT;

/* User manipulations */
/* valid only for IB 5.x or later */

INSERT INTO R_TEST_RFUNC VALUES ('User functions', '----------------');

/* Define valid protocol (1-TCP, 2-NetBEUI, 4-local) and server name */
INSERT INTO R_TEST_RFUNC VALUES ('Add_User()', add_user(4, '', 'RFUNC', 'qwerty', '', 'rFunc', 'UDF', 'Library', 'SYSDBA', 'masterke'));
INSERT INTO R_TEST_RFUNC VALUES ('Modify_User()', modify_user(4, '', 'RFUNC', '123', '', 'rFunc', 'UDF', 'Library!!!', 'SYSDBA', 'masterke'));
INSERT INTO R_TEST_RFUNC VALUES ('Delete_User()', delete_user(4, '', 'RFUNC', 'SYSDBA', 'masterke'));
COMMIT;

/* Simple parser */

INSERT INTO R_TEST_RFUNC VALUES ('Parser functions', '----------------');

INSERT INTO R_TEST_RFUNC VALUES ('CalcExpr("Sin(Pi*:p11/3)*:P2", "P11=2;P2=10")', calcexpr('Sin(Pi*:p11/3)*:P2', 'P11=2;P2=10'));
INSERT INTO R_TEST_RFUNC VALUES ('ExprIsValid("Sin(Pi*:p11/3)*:P2", "P11=2;P2=10")', exprisvalid('Sin(Pi*:p11/3)*:P2', 'P11=2;P2=10'));
INSERT INTO R_TEST_RFUNC VALUES ('CalcExpr("SinFFF(Pi*:p11/3)*:P2", "P11=2;P2=10")', calcexpr('SinFFF(Pi*:p11/3)*:P2', 'P11=2;P2=10'));
INSERT INTO R_TEST_RFUNC VALUES ('ExprIsValid("SinFFF(Pi*:p11/3)*:P2", "P11=2;P2=10") [known bug]', exprisvalid('SinFFF(Pi*:p11/3)*:P2', 'P11=2;P2=10'));
INSERT INTO R_TEST_RFUNC VALUES ('ExprIsValid("Sin(Pi*:p11/*3)*:P2", "P11=2;P2=10")', exprisvalid('Sin(Pi*:p11/*3)*:P2', 'P11=2;P2=10'));
INSERT INTO R_TEST_RFUNC VALUES ('CalcExpr("Avg(0, :p1, :P2)", "p1=2;p2=10") [known bug]', calcexpr('Avg(0, :p1, :P2)', 'p1=2;p2=10'));
INSERT INTO R_TEST_RFUNC VALUES ('CalcExpr("Avg(0, :p1, :P2)", "P1=2;P2=10")', calcexpr('Avg(0, :p1, :P2)', 'P1=2;P2=10'));
INSERT INTO R_TEST_RFUNC VALUES ('CalcExpr("Max(0, :p1, :p2, :p1*:p2)", "P1=2;P2=10")', calcexpr('Max(0, :p1, :p2, :p1*:p2)', 'P1=2;P2=10'));
COMMIT;

/* Blob functions */

INSERT INTO R_TEST_RFUNC VALUES ('BLOB functions', '----------------');
EXECUTE PROCEDURE R_RFUNC_TEST_BLOB;
COMMIT;
